# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::DataFactory::Mgmt::V2017_09_01_preview
  module Models
    #
    # Azure Batch linked service.
    #
    class AzureBatchLinkedService < LinkedService

      include MsRestAzure


      def initialize
        @type = "AzureBatch"
      end

      attr_accessor :type

      # @return The Azure Batch account name. Type: string (or Expression with
      # resultType string).
      attr_accessor :account_name

      # @return [SecretBase] The Azure Batch account access key.
      attr_accessor :access_key

      # @return The Azure Batch URI. Type: string (or Expression with
      # resultType string).
      attr_accessor :batch_uri

      # @return The Azure Batch pool name. Type: string (or Expression with
      # resultType string).
      attr_accessor :pool_name

      # @return [LinkedServiceReference] The Azure Storage linked service
      # reference.
      attr_accessor :linked_service_name

      # @return The encrypted credential used for authentication. Credentials
      # are encrypted using the integration runtime credential manager. Type:
      # string (or Expression with resultType string).
      attr_accessor :encrypted_credential


      #
      # Mapper for AzureBatchLinkedService class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'AzureBatch',
          type: {
            name: 'Composite',
            class_name: 'AzureBatchLinkedService',
            model_properties: {
              additional_properties: {
                client_side_validation: true,
                required: false,
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ObjectElementType',
                      type: {
                        name: 'Object'
                      }
                  }
                }
              },
              connect_via: {
                client_side_validation: true,
                required: false,
                serialized_name: 'connectVia',
                type: {
                  name: 'Composite',
                  class_name: 'IntegrationRuntimeReference'
                }
              },
              description: {
                client_side_validation: true,
                required: false,
                serialized_name: 'description',
                type: {
                  name: 'String'
                }
              },
              parameters: {
                client_side_validation: true,
                required: false,
                serialized_name: 'parameters',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ParameterSpecificationElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'ParameterSpecification'
                      }
                  }
                }
              },
              annotations: {
                client_side_validation: true,
                required: false,
                serialized_name: 'annotations',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ObjectElementType',
                      type: {
                        name: 'Object'
                      }
                  }
                }
              },
              type: {
                client_side_validation: true,
                required: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              account_name: {
                client_side_validation: true,
                required: true,
                serialized_name: 'typeProperties.accountName',
                type: {
                  name: 'Object'
                }
              },
              access_key: {
                client_side_validation: true,
                required: false,
                serialized_name: 'typeProperties.accessKey',
                type: {
                  name: 'Composite',
                  polymorphic_discriminator: 'type',
                  uber_parent: 'SecretBase',
                  class_name: 'SecretBase'
                }
              },
              batch_uri: {
                client_side_validation: true,
                required: true,
                serialized_name: 'typeProperties.batchUri',
                type: {
                  name: 'Object'
                }
              },
              pool_name: {
                client_side_validation: true,
                required: true,
                serialized_name: 'typeProperties.poolName',
                type: {
                  name: 'Object'
                }
              },
              linked_service_name: {
                client_side_validation: true,
                required: true,
                serialized_name: 'typeProperties.linkedServiceName',
                default_value: {},
                type: {
                  name: 'Composite',
                  class_name: 'LinkedServiceReference'
                }
              },
              encrypted_credential: {
                client_side_validation: true,
                required: false,
                serialized_name: 'typeProperties.encryptedCredential',
                type: {
                  name: 'Object'
                }
              }
            }
          }
        }
      end
    end
  end
end
