# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::DataFactory::Mgmt::V2017_09_01_preview
  module Models
    #
    # A WebLinkedService that uses client certificate based authentication to
    # communicate with an HTTP endpoint. This scheme follows mutual
    # authentication; the server must also provide valid credentials to the
    # client.
    #
    class WebClientCertificateAuthentication < WebLinkedServiceTypeProperties

      include MsRestAzure


      def initialize
        @authenticationType = "ClientCertificate"
      end

      attr_accessor :authenticationType

      # @return [SecretBase] Base64-encoded contents of a PFX file.
      attr_accessor :pfx

      # @return [SecretBase] Password for the PFX file.
      attr_accessor :password


      #
      # Mapper for WebClientCertificateAuthentication class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ClientCertificate',
          type: {
            name: 'Composite',
            class_name: 'WebClientCertificateAuthentication',
            model_properties: {
              url: {
                client_side_validation: true,
                required: true,
                serialized_name: 'url',
                type: {
                  name: 'Object'
                }
              },
              authenticationType: {
                client_side_validation: true,
                required: true,
                serialized_name: 'authenticationType',
                type: {
                  name: 'String'
                }
              },
              pfx: {
                client_side_validation: true,
                required: true,
                serialized_name: 'pfx',
                type: {
                  name: 'Composite',
                  polymorphic_discriminator: 'type',
                  uber_parent: 'SecretBase',
                  class_name: 'SecretBase'
                }
              },
              password: {
                client_side_validation: true,
                required: true,
                serialized_name: 'password',
                type: {
                  name: 'Composite',
                  polymorphic_discriminator: 'type',
                  uber_parent: 'SecretBase',
                  class_name: 'SecretBase'
                }
              }
            }
          }
        }
      end
    end
  end
end
