# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::DataFactory::Mgmt::V2018_06_01
  module Models
    #
    # Linked service for Amazon S3.
    #
    class AmazonS3LinkedService < LinkedService

      include MsRestAzure


      def initialize
        @type = "AmazonS3"
      end

      attr_accessor :type

      # @return The access key identifier of the Amazon S3 Identity and Access
      # Management (IAM) user. Type: string (or Expression with resultType
      # string).
      attr_accessor :access_key_id

      # @return [SecretBase] The secret access key of the Amazon S3 Identity
      # and Access Management (IAM) user.
      attr_accessor :secret_access_key

      # @return This value specifies the endpoint to access with the S3
      # Connector. This is an optional property; change it only if you want to
      # try a different service endpoint or want to switch between https and
      # http. Type: string (or Expression with resultType string).
      attr_accessor :service_url

      # @return The encrypted credential used for authentication. Credentials
      # are encrypted using the integration runtime credential manager. Type:
      # string (or Expression with resultType string).
      attr_accessor :encrypted_credential


      #
      # Mapper for AmazonS3LinkedService class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'AmazonS3',
          type: {
            name: 'Composite',
            class_name: 'AmazonS3LinkedService',
            model_properties: {
              additional_properties: {
                client_side_validation: true,
                required: false,
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ObjectElementType',
                      type: {
                        name: 'Object'
                      }
                  }
                }
              },
              connect_via: {
                client_side_validation: true,
                required: false,
                serialized_name: 'connectVia',
                type: {
                  name: 'Composite',
                  class_name: 'IntegrationRuntimeReference'
                }
              },
              description: {
                client_side_validation: true,
                required: false,
                serialized_name: 'description',
                type: {
                  name: 'String'
                }
              },
              parameters: {
                client_side_validation: true,
                required: false,
                serialized_name: 'parameters',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ParameterSpecificationElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'ParameterSpecification'
                      }
                  }
                }
              },
              annotations: {
                client_side_validation: true,
                required: false,
                serialized_name: 'annotations',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ObjectElementType',
                      type: {
                        name: 'Object'
                      }
                  }
                }
              },
              type: {
                client_side_validation: true,
                required: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              access_key_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'typeProperties.accessKeyId',
                type: {
                  name: 'Object'
                }
              },
              secret_access_key: {
                client_side_validation: true,
                required: false,
                serialized_name: 'typeProperties.secretAccessKey',
                type: {
                  name: 'Composite',
                  polymorphic_discriminator: 'type',
                  uber_parent: 'SecretBase',
                  class_name: 'SecretBase'
                }
              },
              service_url: {
                client_side_validation: true,
                required: false,
                serialized_name: 'typeProperties.serviceUrl',
                type: {
                  name: 'Object'
                }
              },
              encrypted_credential: {
                client_side_validation: true,
                required: false,
                serialized_name: 'typeProperties.encryptedCredential',
                type: {
                  name: 'Object'
                }
              }
            }
          }
        }
      end
    end
  end
end
