# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::DataFactory::Mgmt::V2018_06_01
  module Models
    #
    # A file in an HTTP web server.
    #
    class HttpDataset < Dataset

      include MsRestAzure


      def initialize
        @type = "HttpFile"
      end

      attr_accessor :type

      # @return The relative URL based on the URL in the HttpLinkedService
      # refers to an HTTP file Type: string (or Expression with resultType
      # string).
      attr_accessor :relative_url

      # @return The HTTP method for the HTTP request. Type: string (or
      # Expression with resultType string).
      attr_accessor :request_method

      # @return The body for the HTTP request. Type: string (or Expression with
      # resultType string).
      attr_accessor :request_body

      # @return The headers for the HTTP Request. e.g.
      # request-header-name-1:request-header-value-1
      # ...
      # request-header-name-n:request-header-value-n Type: string (or
      # Expression with resultType string).
      attr_accessor :additional_headers

      # @return [DatasetStorageFormat] The format of files.
      attr_accessor :format

      # @return [DatasetCompression] The data compression method used on files.
      attr_accessor :compression


      #
      # Mapper for HttpDataset class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'HttpFile',
          type: {
            name: 'Composite',
            class_name: 'HttpDataset',
            model_properties: {
              additional_properties: {
                client_side_validation: true,
                required: false,
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ObjectElementType',
                      type: {
                        name: 'Object'
                      }
                  }
                }
              },
              description: {
                client_side_validation: true,
                required: false,
                serialized_name: 'description',
                type: {
                  name: 'String'
                }
              },
              structure: {
                client_side_validation: true,
                required: false,
                serialized_name: 'structure',
                type: {
                  name: 'Object'
                }
              },
              schema: {
                client_side_validation: true,
                required: false,
                serialized_name: 'schema',
                type: {
                  name: 'Object'
                }
              },
              linked_service_name: {
                client_side_validation: true,
                required: true,
                serialized_name: 'linkedServiceName',
                default_value: {},
                type: {
                  name: 'Composite',
                  class_name: 'LinkedServiceReference'
                }
              },
              parameters: {
                client_side_validation: true,
                required: false,
                serialized_name: 'parameters',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ParameterSpecificationElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'ParameterSpecification'
                      }
                  }
                }
              },
              annotations: {
                client_side_validation: true,
                required: false,
                serialized_name: 'annotations',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ObjectElementType',
                      type: {
                        name: 'Object'
                      }
                  }
                }
              },
              folder: {
                client_side_validation: true,
                required: false,
                serialized_name: 'folder',
                type: {
                  name: 'Composite',
                  class_name: 'DatasetFolder'
                }
              },
              type: {
                client_side_validation: true,
                required: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              relative_url: {
                client_side_validation: true,
                required: false,
                serialized_name: 'typeProperties.relativeUrl',
                type: {
                  name: 'Object'
                }
              },
              request_method: {
                client_side_validation: true,
                required: false,
                serialized_name: 'typeProperties.requestMethod',
                type: {
                  name: 'Object'
                }
              },
              request_body: {
                client_side_validation: true,
                required: false,
                serialized_name: 'typeProperties.requestBody',
                type: {
                  name: 'Object'
                }
              },
              additional_headers: {
                client_side_validation: true,
                required: false,
                serialized_name: 'typeProperties.additionalHeaders',
                type: {
                  name: 'Object'
                }
              },
              format: {
                client_side_validation: true,
                required: false,
                serialized_name: 'typeProperties.format',
                type: {
                  name: 'Composite',
                  polymorphic_discriminator: 'type',
                  uber_parent: 'DatasetStorageFormat',
                  class_name: 'DatasetStorageFormat'
                }
              },
              compression: {
                client_side_validation: true,
                required: false,
                serialized_name: 'typeProperties.compression',
                type: {
                  name: 'Composite',
                  polymorphic_discriminator: 'type',
                  uber_parent: 'DatasetCompression',
                  class_name: 'DatasetCompression'
                }
              }
            }
          }
        }
      end
    end
  end
end
