# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::DataFactory::Mgmt::V2018_06_01
  module Models
    #
    # A copy activity source for SAP Business Warehouse Open Hub Destination
    # source.
    #
    class SapOpenHubSource < TabularSource

      include MsRestAzure


      def initialize
        @type = "SapOpenHubSource"
      end

      attr_accessor :type

      # @return Whether to exclude the records of the last request. The default
      # value is true. Type: boolean (or Expression with resultType boolean).
      attr_accessor :exclude_last_request

      # @return The ID of request for delta loading. Once it is set, only data
      # with requestId larger than the value of this property will be
      # retrieved. The default value is 0. Type: integer (or Expression with
      # resultType integer ).
      attr_accessor :base_request_id


      #
      # Mapper for SapOpenHubSource class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'SapOpenHubSource',
          type: {
            name: 'Composite',
            class_name: 'SapOpenHubSource',
            model_properties: {
              additional_properties: {
                client_side_validation: true,
                required: false,
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ObjectElementType',
                      type: {
                        name: 'Object'
                      }
                  }
                }
              },
              source_retry_count: {
                client_side_validation: true,
                required: false,
                serialized_name: 'sourceRetryCount',
                type: {
                  name: 'Object'
                }
              },
              source_retry_wait: {
                client_side_validation: true,
                required: false,
                serialized_name: 'sourceRetryWait',
                type: {
                  name: 'Object'
                }
              },
              max_concurrent_connections: {
                client_side_validation: true,
                required: false,
                serialized_name: 'maxConcurrentConnections',
                type: {
                  name: 'Object'
                }
              },
              type: {
                client_side_validation: true,
                required: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              query_timeout: {
                client_side_validation: true,
                required: false,
                serialized_name: 'queryTimeout',
                type: {
                  name: 'Object'
                }
              },
              additional_columns: {
                client_side_validation: true,
                required: false,
                serialized_name: 'additionalColumns',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'AdditionalColumnsElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'AdditionalColumns'
                      }
                  }
                }
              },
              exclude_last_request: {
                client_side_validation: true,
                required: false,
                serialized_name: 'excludeLastRequest',
                type: {
                  name: 'Object'
                }
              },
              base_request_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'baseRequestId',
                type: {
                  name: 'Object'
                }
              }
            }
          }
        }
      end
    end
  end
end
