# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::DataFactory::Mgmt::V2018_06_01
  module Models
    #
    # Get Data Plane read only token request definition.
    #
    class UserAccessPolicy

      include MsRestAzure

      # @return [String] The string with permissions for Data Plane access.
      # Currently only 'r' is supported which grants read only access.
      attr_accessor :permissions

      # @return [String] The resource path to get access relative to factory.
      # Currently only empty string is supported which corresponds to the
      # factory resource.
      attr_accessor :access_resource_path

      # @return [String] The name of the profile. Currently only the default is
      # supported. The default value is DefaultProfile.
      attr_accessor :profile_name

      # @return [String] Start time for the token. If not specified the current
      # time will be used.
      attr_accessor :start_time

      # @return [String] Expiration time for the token. Maximum duration for
      # the token is eight hours and by default the token will expire in eight
      # hours.
      attr_accessor :expire_time


      #
      # Mapper for UserAccessPolicy class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'UserAccessPolicy',
          type: {
            name: 'Composite',
            class_name: 'UserAccessPolicy',
            model_properties: {
              permissions: {
                client_side_validation: true,
                required: false,
                serialized_name: 'permissions',
                type: {
                  name: 'String'
                }
              },
              access_resource_path: {
                client_side_validation: true,
                required: false,
                serialized_name: 'accessResourcePath',
                type: {
                  name: 'String'
                }
              },
              profile_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'profileName',
                type: {
                  name: 'String'
                }
              },
              start_time: {
                client_side_validation: true,
                required: false,
                serialized_name: 'startTime',
                type: {
                  name: 'String'
                }
              },
              expire_time: {
                client_side_validation: true,
                required: false,
                serialized_name: 'expireTime',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
