# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::DataFactory::Mgmt::V2018_06_01
  module Models
    #
    # Web activity authentication properties.
    #
    class WebActivityAuthentication

      include MsRestAzure

      # @return [String] Web activity authentication
      # (Basic/ClientCertificate/MSI)
      attr_accessor :type

      # @return [SecretBase] Base64-encoded contents of a PFX file.
      attr_accessor :pfx

      # @return [String] Web activity authentication user name for basic
      # authentication.
      attr_accessor :username

      # @return [SecretBase] Password for the PFX file or basic authentication.
      attr_accessor :password

      # @return [String] Resource for which Azure Auth token will be requested
      # when using MSI Authentication.
      attr_accessor :resource


      #
      # Mapper for WebActivityAuthentication class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'WebActivityAuthentication',
          type: {
            name: 'Composite',
            class_name: 'WebActivityAuthentication',
            model_properties: {
              type: {
                client_side_validation: true,
                required: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              pfx: {
                client_side_validation: true,
                required: false,
                serialized_name: 'pfx',
                type: {
                  name: 'Composite',
                  polymorphic_discriminator: 'type',
                  uber_parent: 'SecretBase',
                  class_name: 'SecretBase'
                }
              },
              username: {
                client_side_validation: true,
                required: false,
                serialized_name: 'username',
                type: {
                  name: 'String'
                }
              },
              password: {
                client_side_validation: true,
                required: false,
                serialized_name: 'password',
                type: {
                  name: 'Composite',
                  polymorphic_discriminator: 'type',
                  uber_parent: 'SecretBase',
                  class_name: 'SecretBase'
                }
              },
              resource: {
                client_side_validation: true,
                required: false,
                serialized_name: 'resource',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
